C
C      9. SUBROUTINE FOR DATA PREPARATION FOR NE PROFILE
C                       CALCULATIONS
C
      SUBROUTINE SH1(HI,DAY,PN,IP,A)
C  LOW AND MID-LATITUDES. INTERPOLATION OF COEF. ANE WITH ZENITH ANGLE.
      REAL*8 A(13)
      NHI=IFIX((HI+10**(-5))/10.0)
      DHI=HI/10.0-NHI
      IF (NHI.GE.15) NHI=15
      IF (NHI.LE.1) NHI=1
      K=NHI+1
      IF ((NHI.EQ.1).OR.(NHI.EQ.15)) K=NHI
C     MID-SEASON:  1-WINTER  2-EQUINOX  3-SUMMER
      IF ((DAY.LE.31.0).OR.(DAY.GE.335.)) CALL AKNE1(1,IP,NHI,K,DHI,A)
      IF (DAY.GE.152.0.AND.DAY.LE.212.) CALL AKNE1(3,IP,NHI,K,DHI,A)
      IF (DAY.EQ.90.0.OR.DAY.EQ.273.) CALL AKNE1(2,IP,NHI,K,DHI,A)
C     INTER-SEASONS: WINTER-EQUINOX SUMMER-EQUINOX
      IF (DAY.GT.31.0.AND.DAY.LT.90.) CALL BKNE1(1,IP,NHI,K,DHI,PN,A,1)
      IF (DAY.GT.273.0.AND.DAY.LT.335.) CALL BKNE1(1,IP,NHI,K,DHI,PN,
     *A,2)
      IF (DAY.GT.90.0.AND.DAY.LT.152.) CALL BKNE1(3,IP,NHI,K,DHI,PN,A,2)
      IF (DAY.GT.212.0.AND.DAY.LT.273.) CALL BKNE1(3,IP,NHI,K,DHI,PN,
     *A,1)
      RETURN
      END
C
      SUBROUTINE SH2(HI,DAY,PN,A)
      REAL*8 A(13)
C  SUBAURORAL REGION. INTERPOLATION OF COEF. ANE WITH ZENITH ANGLE
      IF ((HI.GT.30.).AND.(HI.LT.110.)) GO TO 1
      IF (HI.LE.30.) NHI=1
      IF (HI.GE.110.) NHI=9
      DHI=1.
      K=NHI
      GO TO 2
    1 NHI=IFIX(HI/10.)-2
      K=NHI+1
      DHI=0.1*HI-IFIX(HI/10.)
C     MID-SEASON:  1-WINTER, 2-EQUINOX, 3-SUMMER
    2 IF ((DAY.LE.31.).OR.(DAY.GE.335.)) CALL AKNE2(1,NHI,K,DHI,A)
      IF (DAY.GE.152.0.AND.DAY.LE.212.) CALL AKNE2(3,NHI,K,DHI,A)
      IF (DAY.EQ.90.0.OR.DAY.EQ.273.) CALL AKNE2(2,NHI,K,DHI,A)
C     INTER-SEASONS: WINTER-EQUINOZ, SUMMER-EQUINOX
      IF (DAY.GT.31.0.AND.DAY.LT.90.) CALL BKNE2(1,NHI,K,DHI,PN,A,1)
      IF (DAY.GT.273.0.AND.DAY.LT.335.) CALL BKNE2(1,NHI,K,DHI,PN,A,2)
      IF (DAY.GT.90.0.AND.DAY.LT.152.) CALL BKNE2(3,NHI,K,DHI,PN,A,2)
      IF (DAY.GT.212.0.AND.DAY.LT.273.) CALL BKNE2(3,NHI,K,DHI,PN,A,1)
      RETURN
      END
C
      SUBROUTINE SHINT(HI,DAY,PN,IP,A)
      REAL*8 A1(13),A2(13),A(13),INTP
      COMMON /B6/HMLAT,H0NE,GLT,FGR1,FGR2
C     INTERPOLATION OF COEF. ANE WITH LATITUDE
      DSH=(ABS(HMLAT)-FGR1)/(FGR2-FGR1)
      CALL SH1(HI,DAY,PN,IP,A1)
      CALL SH2(HI,DAY,PN,A2)
      DO 1 I=1,13
    1 A(I)=INTP(A1(I),A2(I),DSH)
      RETURN
      END
C
      SUBROUTINE SMAS(XKP)
      REAL*8 FKW(10),FKC(50)
      COMMON /B5/FKW,NB/B6/HMLAT,H0,GLT,FG1,FG2
     &/BENOY/KP,AS,BS,CS
      DATA FKC /22.34, 16.36,-67.09,608.97,-3293.47,9158.42,-14251.56,
     112649.62,-6002.40,1183.62,23.22,14.08,-58.69,611.31,-3692.39,
     211270.38,-19147.75,18514.66,-9559.41,2049.56,24.20,11.05,-39.85,
     3415.04,-2554.19,7726.47,-12911.61,12290.60,-6272.97,1336.37,
     424.24,15.54,-38.11,368.21,-2886.72,10120.41,-18706.27,19199.34,
     5-10387.30,2315.81,24.36,14.70,64.36,-389.34,-616.99,6891.25,
     6-17030.36, 20108.82, -11833.09, 2791.48/
      KP=IFIX(XKP)
      IF ((XKP-KP).GT.0.5) KP=KP+1
      IF (KP.GT.6) KP=6
      IF ((GLT.LT.8.0).OR.(GLT.GE.16.0)) GO TO 1
      IF (KP.GE.1) GO TO 2
      NB=0
      GO TO 3
    1 NB=KP+1
      GO TO 4
    2 NB=KP
    4 IF (NB.GT.5) NB=5
      KL=NB*10-10
      DO 5 IK=1,10
    5 FKW(IK)=FKC(KL+IK)
C--- BORDERS OF AURORAL OVAL FOR GIVEN KP AND GLT ARE CALCULATED ---
C--- BY CUBIC SPLINE WITH PERIODIC LIMITING CONDITIONS ---------
C--- SUBROUTINES SPL,SPLINE,MI
    3 CALL SPL(KP,GLT,AS,BS,CS)
      RETURN
      END
C
      SUBROUTINE AKNE1(J,IP,NHI,K,DHI,A)
      REAL*8 ANE1(3,2,15,13),A(13),INTP
      COMMON/B1/ANE1
C     LOW AND MID-LATITUDE MODEL; MID-SEASON
C     INTERPOLATION WITH ZENITH ANGLE
      DO 1 I=1,13
    1 A(I)=INTP(ANE1(J,IP,NHI,I),ANE1(J,IP,K,I),DHI)
      RETURN
      END
C
      SUBROUTINE BKNE1(J,IP,NHI,K,DHI,PN,A,LM)
      REAL*8 ANE1(3,2,15,13),A(13),A11,A21,INTP
      COMMON/B1/ANE1
C     LOW AND MID-LATITUDE MODEL; MID-SEASON
C     INTERPOLATION WITH ZENITH ANGLE
      IF (LM.EQ.2) GO TO 3
      DO 1 I=1,13
      A11=INTP(ANE1(J,IP,NHI,I),ANE1(J,IP,K,I),DHI)
      A21=INTP(ANE1(2,IP,NHI,I),ANE1(2,IP,K,I),DHI)
    1 A(I)=INTP(A11,A21,PN)
      GO TO 8
    3 DO 2 I=1,13
      A11=INTP(ANE1(2,IP,NHI,I),ANE1(2,IP,K,I),DHI)
      A21=INTP(ANE1(J,IP,NHI,I),ANE1(J,IP,K,I),DHI)
    2 A(I)=INTP(A11,A21,PN)
    8 RETURN
      END
C
      SUBROUTINE AKNE2(J,NHI,K,DHI,A)
      REAL*8 ANE2(3,9,11),A(13),INTP
      COMMON/B2/ANE2
C     SUB-AURORAL REGION; MID-SEASON
C     INTERPOLATION OF COEF. ANE WITH ZENITH ANGLE
      DO 1 I=1,11
    1 A(I)=INTP(ANE2(J,NHI,I),ANE2(J,K,I),DHI)
      A(13)=A(11)
      A(11)=0.
      A(12)=0.
      RETURN
      END
C
      SUBROUTINE BKNE2(J,NHI,K,DHI,XN,A,LM)
      REAL*8 ANE2(3,9,11),A(13),A11,A21,INTP
      COMMON/B2/ANE2
C     SUB-AURORAL REGION; INTER-SEASON
C     INTERPOLATION OF COEF. ANE WITH ZENITH ANGLE
      IF (LM.EQ.2) GO TO 3
      DO 1 I=1,11
      A11=INTP(ANE2(J,NHI,I),ANE2(J,K,I),DHI)
      A21=INTP(ANE2(2,NHI,I),ANE2(2,K,I),DHI)
    1 A(I)=INTP(A11,A21,XN)
      GO TO 8
    3 DO 2 I=1,11
      A11=INTP(ANE2(2,NHI,I),ANE2(2,K,I),DHI)
      A21=INTP(ANE2(J,NHI,I),ANE2(J,K,I),DHI)
    2 A(I)=INTP(A11,A21,XN)
    8 A(13)=A(11)
      A(11)=0.
      A(12)=0.
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION INTP(A1,A2,X)
      REAL*8 A1,A2
      INTP=A1+(A2-A1)*X
      RETURN
      END
C
      FUNCTION ENOYS(NEY,FK1,FK,NES,H)
      REAL NES,NEY,ENOYS,M,N,NEO
      COMMON /B6/HMLAT,H0,GLT,FG1,FG2
C--- VALUE OF NE IS CALCULATED EQUAL TO THE BOTH HEMISPHERES ---------
      FI=ABS(HMLAT)
C--- SUBROUTINE OVAL CALCULATES ELECTRON CONCENTRATION IN THE---------
C--- POLAR LATITUDES WITHOUT ULTRA-VIOLET EMISSION ------------
      CALL OVAL(FI,FK1,FK,NEO,H)
      S=NES
      X=GLT-8.
      Y=FI-FG2
      XY=(X/2.)**4+(Y/3.)**4
      IF(XY.LT.1.) GO TO 31
      GO TO 32
   31 IF(NEY.LE.NES) GO TO 32
      C=NEY/NES
      C=ALOG(C)
      N=C/81.
      M=C/16.
      S=NEY/EXP(M*X**4+N*Y**4)
      IF(NEO.LT.1.E-3) NEO=0.
   32 ENOYS=SQRT(NEO**2+S**2)
      RETURN
      END
C
      SUBROUTINE OVAL(FI,FK1,FK,NE,H)
      REAL NE,NE1
      COMMON /BENOY/KP,AS,BS,CS
      AL=(FK-FK1)/(AS-CS)**2
      NE1=-2*AL*(AS-CS)
C--- SELECTION OF FORMULA FOR OVAL CALCULATION DEPENDING ON LATITUDE(FI) ---   
      IF(FI-AS) 21,22,23
   21 IF(FI-BS) 24,22,25
   22 NE=FK1
      GO TO 5
   23 AB=AS
      DFI=(220.-H)/40.
      GO TO 11
   24 AB=BS
      DFI=FK/(6.*FK1)
      IF (DFI.GT.12.) DFI=12.
   11 A=-FK1/NE1
      B=A*FK1
C--- DFI - WIDTH OF DECAY------------------------------------------
      X=ABS(FI-AB)/DFI
      IF(X.LE.2) GO TO 11111
      NE=0.
      GO TO 5
11111 NE=B*EXP(-X**2)/(A+X)
      GO TO 5
   25 NE=-AL*(FI-CS)**2+FK
    5 RETURN
      END
C
       SUBROUTINE SPL(KP,GLT,AS,BS,CS)
       DIMENSION X(7),AA(7,7),BB(7,7),XX(3)
       DIMENSION Y(7)
C--- ARRAY X INCLUDE NODE POINTS, FOR WHICH VALUES OF BORDER  ------
C--- OF OVAL ARE GIVEN FOR DIFFERENT KP --------------------------------
       DATA   X/0.,4.,8.,12.,16.,20.,24./,
C--- NEAR-POLAR BORDERS OF OVAL FOR DIFFERENT KP=0,1,...,6 ,-------------
C--- [SEE:G.V.STARKOV,YA.I.FELDSTEIN, GEOMAGN. AERONOMY,7,1,62-71,
C--- 1967;POLAR. SIJANIJA, 17,22-33,1968].
     *       AA/74.3,75.5,74.5,80.2,79.5,75.5,74.3,
     *          73.,75.2,74.8,79.,78.,75.3,73.,
     *          72.3,75.,75.,78.,76.5,75.2,72.3,
     *          72.8,75.,75.2,76.8,75.7,75.1,72.8,
     *          73.4,75.3,74.6,76.,75.,75.,73.4,
     *          74.,75.5,73.7,75.3,74.7,74.5,74.,
     *          75.,75.6,72.1,74.5,74.3,74.,75./,
C--- EQUATORIAL BORDERS OF OVAL FOR DIFFERENT KP=0,1,...,6 , --------
C--- [SEE:G.V.STARKOV,YA.I.FELDSTEIN, GEOMAGN. AERONOMY,7,1,62-71,
C--- 1967;POLAR. SIJANIJA,17,22-33,1968].

     *       BB/65.5,67.8,72.3,76.6,76.3,71.5,65.5,
     *          64.3,66.5,71.8,75.4,74.6,69.,64.3,
     *          63.4,65.,71.,74.2,73.,67.,63.4,
     *          62.5,63.7,70.3,73.1,71.7,65.5,62.5,
     *          61.5,62.5,69.3,72.,70.1,64.3,61.5,
     *          60.7,61.5,68.,71.,68.2,63.6,60.7,
     *          59.6,60.7,66.4,70.,66.3,63.3,59.6/
C--- SELECTION OF INTERVAL FOR INTERPOLATION---------------------------
      DO 6 I=1,7
      IF(GLT.EQ.X(I)) GO TO 8
      IF(GLT.GT.X(I).AND.GLT.LT.X(I+1)) GO TO 7
      GO TO 6
    7 IY=I
      XX(1)=X(I)
      XX(3)=X(I+1)
      GO TO 10
    8 AS=AA(I,KP+1)
      BS=BB(I,KP+1)
      GO TO 11
    6 CONTINUE
   10 XX(2)=GLT
       L=1
       DO 1 J=1,7
    1  Y(J)=AA(J,KP+1)
    5  CALL SPLINE(Y,7,XX,IY,S)
       IF(L.EQ.1) GO TO 3
       GO TO 2
    3  AS=S
       L=2
       DO 4 J=1,7
    4  Y(J)=BB(J,KP+1)
       GO TO 5
    2  BS=S
   11  CS=(AS+BS)/2.
    9 RETURN
      END
C
      SUBROUTINE SPLINE(Y,N,XX,IY,S)
C--- [YU.S. ZAVJALOV ET AL, METHODS OF SPLINE-FUNCTIONS,1980,96-101].
      DIMENSION Y(7),H(7),C(7),A(7)
      REAL LM(7),MU(7),M(7),XX(3)
      N1=N-1
      DO 1 I=1,N
      A(I)=2.
      H(I)=4.
      MU(I)=1./2.
      LM(I)=1.-MU(I)
    1 CONTINUE
      DO 2 I=2,N1
      C(I)=3*(MU(I)*(Y(I+1)-Y(I))/H(I)+LM(I)*(Y(I)-Y(I-1))/H(I-1))
    2 CONTINUE
      C(N)=3*(MU(N)*(Y(2)-Y(N))/H(N)+LM(N)*(Y(N)-Y(N-1))/H(N-1))
      CALL MI(A,MU,LM,C,N,M)
      T=(XX(2)-XX(1))/H(IY)
C--- CALCULATION OF VALUE OF CUBIC SPLINE - S -----------------------
C--- HERE Y - VALUE OF BORDER (SUB-POLAR OR EQUATORIAL BORDER) AT NODES
C--- OF INTERVAL; IY - No. OF INTERVAL; M - SPLINE COEFFICIENTS CALCULATED
C--- WITH SUBROUTINE  MI ----------------------------------------
      S=Y(IY)*(1-T)**2*(1+2*T)+Y(IY+1)*T**2*
     *(3-2*T)+M(IY)*H(IY)*T*(1-T)**2-
     -M(IY+1)*H(IY)*T**2*(1-T)
  111 RETURN
      END
C
      SUBROUTINE MI(A,B,C,D,N,Y)
C--- [YU.S. ZAVJALOV ET AL, METHODS OF SPLINE-FUNCTIONS,1980,336-342].
C--CALCULATION OF COEFFICIENTS (Y) OF CUBIC SPLINE --------------------
      REAL C(7),B(7),D(7),Y(7),A(7)
      REAL V(7),U(7),W(7),S(7),T(7)
C----------- STRAIGHT CALCULATION--------------------------------------
      N1=N-1
      V(1)=0.
      U(1)=0.
      W(1)=1.
      DO 1 I=2,6
      ACV=A(I)+C(I)*V(I-1)
      V(I)=-B(I)/ACV
      U(I)=(D(I)-C(I)*U(I-1))/ACV
      W(I)=-C(I)*W(I-1)/ACV
    1 CONTINUE
C----------- INVERSE CALCULATION---------------------------------------
      S(N)=1.
      T(N)=0.
      J=N
      DO 2 I=2,N1
      J=J-1
      S(J)=V(J)*S(J+1)+W(J)
      T(J)=V(J)*T(J+1)+U(J)
    2 CONTINUE
      Y(N)=(D(N)-B(N)*T(2)-C(N)*T(N-1))/(A(N)+B(N)*S(2)+
     +C(N)*S(N-1))
      DO 3 I=2,N1
      Y(I)=S(I)*Y(N)+T(I)
    3 CONTINUE
      Y(1)=Y(N)
      RETURN
      END
C
      REAL FUNCTION REAX (NP,H,H0,A)
      REAL*8 A(13),SI,Z0
      IF ((H.LT.H0).AND.(NP.LE.6)) GO TO 2
      Z=(H-H0)/(200.-H0)
      SI=A(1)
      Z0=Z
      DO 1 I=2,NP
      SI=SI+A(I)*Z0
    1 Z0=Z0*Z
      REAX=SNGL(SI)
      RETURN
    2 REAX=-1.
      RETURN
      END
C
      SUBROUTINE RNCOR (XHI,R,YMAGBR,COV)
      EXTERNAL XE5
      COMMON /BL10/HX1,HKX1,HX2,HKX2,HX3,HKX3,HKI1,HKI2
      Y=6.05+0.088*R
      Z=(-0.1/(ALOG(4./Y)))**0.3704
      SUXHI=ACOS(Z)
      IF (SUXHI.LT.1.0472) SUXHI=1.0472
      XXHI=XHI/57.2957795
      IF (XXHI.GT.SUXHI) GOTO 1
      HX1=83.
      HKX1=0.0763941*Y
      GO TO 2
    1 HX1=86.
      HKX1=1.
    2 A=1.0+0.0094*(COV-66.0)
      SP=1.0+0.0098*R
      SMIN=0.017*SP*SP
      CALL PMRE (ENM,HX2,FM,0,XE5)
      FXM=FM*FM
      F=FXM*FXM*0.6274224*A
      HKX2=0.5605*SP
      IF (F.GE.SMIN) HKX2=0.7956*A**0.5
      XMAGBR=ABS(YMAGBR)
      F0=4.35+XMAGBR*(0.0058-(1.2E-04)*XMAGBR)
      F100=5.348+XMAGBR*(0.011-(2.3E-04)*XMAGBR)
      FSC=0.2*F0+0.8*F100
      FS=F0+(F100-F0)*R/100.
      XM=6.0E-04*R-0.048
      COSXHI=COS(XXHI)
      IF (COSXHI.LT.1.74524E-02) COSXHI=1.74524E-02
      HKX3=FS*FS*COSXHI**XM/(FSC*FSC)
      HKPR=0.82+0.00225*R
      IF (R.GE.80.) GO TO 3
      IF (HKX3.GT.HKPR) HKX3=HKPR
      GO TO 4
    3 IF (HKX3.LT.HKPR) HKX3=HKPR
    4 HX3=190.0
      HKI1=(HKX2-HKX1)/(HX2-HX1)
      HKI2=(HKX3-HKX2)/(HX3-HX2)
      RETURN
      END
C
      SUBROUTINE TOPSID(XMLAT,R,HOUR)
      REAL NMF2
      DIMENSION DMLAT(5),RMAS(11,2),HMAS(11,2),RK(11),LT(2),
     &RKFT(11,7,4,4),DH(12),DN(12),DNDH(12),VH(11)
      COMMON/BLOCK1/HMF2,NMF2,HMF1/BLO10/BETA,ETA,DELTA,ZETA
     &/BLOCK6/RKFT/BLOCK/DH,DN,DNDH,KT/A1/EH
      DATA VH/50.,100.,150.,200.,250.,300.,350.,400.,500.,600.,700./
      DATA DMLAT/0.,30.,50.,80.,91./
      FUN(A1,A2,DA)=A1+(A2-A1)*DA
      DMLAT(3)=50.0
      IF (XMLAT.LT.44.0) DMLAT(3)=47.5
      IF (DELTA.LT.-140.0) DELTA=-140.0
      IF (DELTA.GT.320.0) DELTA=320.0
      DO 1 I=1,4
      IF((XMLAT.GE.DMLAT(I)).AND.(XMLAT.LT.DMLAT(I+1))) GO TO 2
   1  CONTINUE
    2 IFI=I
      IF(IFI.GT.3) IFI=3
      DFI=(XMLAT-DMLAT(IFI))/(DMLAT(IFI+1)-DMLAT(IFI))
      DHOUR=HOUR/6.-IFIX(HOUR/6.)
      LT(1)=IFIX(HOUR/6.)+1
      LT(2)=LT(1)+1
      IF(LT(2).GT.4) LT(2)=1
      IF(R.GE.240.) GO TO 8
      DR=R/40.-IFIX(R/40.)
      IR=IFIX(R/40.)+1
      GO TO 3
   8  DR=(R-200.)/40.
      IR=6
   3  CONTINUE
      DO 6 K=1,2
      DO 4 J=1,11
      DO 5 I=1,2
      II=LT(I)
   5  RMAS(J,I)=FUN(RKFT(J,IR,II,IFI),RKFT(J,IR+1,II,IFI),DR)
   4  HMAS(J,K)=FUN(RMAS(J,1),RMAS(J,2),DHOUR)
   6  IFI=IFI+1
      DO 7 I=1,11
      RK(I)=FUN(HMAS(I,1),HMAS(I,2),DFI)
   7  IF (RK(I).LT.0.01) RK(I)=0.01
      DX=100.
      IF ((EH-HMF2).GT.350.) DX=200.
      DH(1)=0.
      DN(1)=0.
      DO 9 I=1,11
      DH(I+1)=VH(I)
      A=VH(I)/(1000.0-HMF2)*700.0
      ARG=(-94.5-DELTA)/BETA
      IF (ABS(ARG).LT.170.0) GO TO 12
      IF (ARG.LT.0.0) ARLN1=0.0
      IF (ARG.GT.0.0) ARLN1=A/BETA
      GO TO 13
   12 ARLN1=ALOG((1.0+EXP(A/BETA)*EXP(ARG))/(1.0+EXP(ARG)))
   13 ARG=-DELTA/100.
      IF (ABS(ARG).LT.170.0) GO TO 14
      IF (ARG.LT.0.0) ARLN2=0.0
      IF (ARG.GT.0.0) ARLN2=A/100.
      GO TO 15
   14 ARLN2=ALOG((1.0+EXP(A/100.)*EXP(ARG))/(1.0+EXP(ARG)))
   15 Y=(1000.0-HMF2)/700.0*(BETA*ETA*ARLN1+ZETA*(100.0*ARLN2-A))
      DN(I+1)=-Y*0.43429+2.*ALOG10(RK(I))
      KT=I+1
      IF ((HMF2+VH(I)).GT.(EH+DX)) GO TO 10
    9 CONTINUE
   10 DH(2)=(DN(3)*VH(1)-DN(2)*VH(2))/(DN(3)-DN(2))
      DN(2)=0.
      DO 11 I=2,KT
   11 DNDH(I-1)=(DN(I)-DN(I-1))/(DH(I)-DH(I-1))
      DNDH(KT)=DNDH(KT-1)
      RETURN
      END
C
      REAL FUNCTION AHCOR (H0,AH,SH)
      IF (AH.LT.H0) GO TO 1
      AHCOR=AH
      RETURN
    1 H=AH
    2 H=H+SH
      IF (H.LT.H0) GO TO 2
      AHCOR=H
      RETURN
      END
C
      SUBROUTINE HSTK(HGF2,ZZ)
      REAL NMF2
      COMMON /BLKS/Y1,Y11,HZ,Y2,Y21,KEY,X0
     &/BLOCK1/HMF2,NMF2,HMF1/BLOCK3/X1
      XM=HMF2
      YM=ALOG(NMF2)
      IF (ZZ.LT.5.0) GO TO 12
      XM=ZZ
      YM=ALOG(XXE(XM))
      X2=ZZ-20.
      IF (ZZ.LT.210.0) X2=ZZ-10.0
      GO TO 8
   12 X2=HGF2
      IF (X2.LT.201.0) X2=201.0
    8 HZ=X2-1.
      Y2=ALOG(XXE(X2))
      Y21=ALOG(XXE(X2+0.5)/XXE(X2-0.5))
      YS21=ABS(Y21)+5.E-04
      IF (Y21.LT.0.0) YS21=YS21*(-1.0)
      Y21=IFIX(YS21*1000)/1000.
      IP=0
      X1=X2-20.
      IF (X1.GT.190.) X1=190.
      Y1=ALOG(XE5(X1))
      Y11=ALOG(XE5(X1+0.5)/XE5(X1-0.5))
      YS11=ABS(Y11)+5.E-04
      IF (Y11.LT.0.0) YS11=YS11*(-1.0)
      Y11=IFIX(YS11*1000)/1000.
    6 DELTA=Y11-Y21
      IF ((DELTA.LT.0.).AND.(DELTA.GT.-0.001)) DELTA=-0.001
      IF ((DELTA.GE.0.).AND.(DELTA.LT.0.001)) DELTA=0.001
      X0=(Y11*X1-Y21*X2+Y2-Y1)/DELTA
      YL1=Y1+Y11*(X2-X1)
      YL2=Y2+Y21*(X1-X2)
      YLM=Y11*(XM-X1)+Y1
      DLTX=(X2-X1)/8.
      IF ((X0.GE.(X1+DLTX)).AND.(X0.LE.(X2-DLTX))) GO TO 4
      IF ((Y1.LE.YL2).AND.(Y2.GT.YL1)) GO TO 5
      IF (Y1.LE.YM.AND.Y1.GE.Y2.AND.Y11.LE.0.) GO TO 10
      IF (Y1.GT.YM.AND.YLM.LT.YM) GO TO 21
      XX1=X1-2.0
      YY1=ALOG(XE5(XX1))
      YY11=ALOG(XE5(XX1+0.5)/XE5(XX1-0.5))
      YS11=ABS(YY11)+5.E-04
      IF (YY11.LT.0.0) YS11=YS11*(-1.0)
      YY11=IFIX(YS11*1000)/1000.
      IF (IP.GT.0) GO TO 21
      IF ((YM.GT.Y1).AND.(Y11.GE.0.).AND.(YY11.LT.0.)) GO TO 1
      IF (XX1.LT.110.) GO TO 1
      IF ((XX1.LE.130.).AND.(Y11.LE.0.).AND.(YY11.GE.0.)) GO TO 2
      GO TO 3
    2 XX1=XX1+7.
      YY1=ALOG(XE5(XX1))
      YY11=ALOG(XE5(XX1+0.5)/XE5(XX1-0.5))
      YS11=ABS(YY11)+5.E-04
      IF (YY11.LT.0.0) YS11=YS11*(-1.0)
      YY11=IFIX(YS11*1000)/1000.
    1 IP=1
    3 X1=XX1
      Y1=YY1
      Y11=YY11
      GO TO 6
   21 IF ((YL2.GE.Y1).OR.(YL1.LT.Y2)) GO TO 4
   10 Y2=YM
      X2=XM
      Y21=0.
      IF (Y11.EQ.0.0) Y11=1.E-05
      X0=(Y11*X1+Y2-Y1)/Y11
      IF (Y1.GT.YM) GO TO 11
      IF (YLM.LT.YM) GO TO 5
      GO TO 4
   11 IF (YLM.LT.YM) GO TO 4
      IF (Y11.LT.0.) GO TO 5
      Y11=0.
    5 KEY=1
      GO TO 7
    4 KEY=0
    7 IF (ZZ.LT.5.) HMF1=X2
      HZ=X2
      RETURN
      END
C
C     10. SUBROUTINES FOR DATA PREPARATION FOR CALCULATION OF
C                        TE PROFILE
C
      SUBROUTINE TEK(MLAT,HOUR,SAX,SUX,TD,FI,R)
      REAL M(10),D(9),HP(9),TEP(9),MLAT,HP1(9),DAY(13),TDAY(13)
      COMMON /GTE/M,D,HP,TEP /BLOCD/MON,IDAY/BLO11/XHI
      COMMON /V1/CF4,C04,T4,TI4 /V2/TE2,TE3,TE4,VS,VS25,VSM,DT,DT25,
     *T2,T3 /DM/NI /V5/CF3,C03,TI3 /KT/TT1,TT2
      DATA HP1/160.,190.,300.,400.,600.,1400.,250.,350.,0./
      DATA DAY/1.,32.,60.,91.,121.,152.,182.,213.,244.,274.,305.,335.,
     *366./
      DATA TDAY/0.03,-0.36,0.15,0.1,0.05,-0.05,0.1,-0.25,0.05,
     *0.2,0.3,-0.24,0.03/
      DT=TDAY(MON)+(IDAY-1.)*(TDAY(MON+1)-TDAY(MON))/(DAY(MON+1)-
     *DAY(MON))
      DELTR=R-80.0
      IF (ABS(FI).LE.60.) CALL TE34(0.,TD,HOUR,T3,T4,C03,C04)
      IF (ABS(FI).LE.60.) CALL FITE(0.,HOUR,SAX,SUX,HP1(2),T2,TE2)
      CALL FITE(MLAT,HOUR,SAX,SUX,HP1(1),TE1,TTE2)
      CALL FITE(MLAT,HOUR,SAX,SUX,HP1(2),TE2,TTE2)
      CALL TE34(FI,TD,HOUR,TE3,TE4,CF3,CF4)
      IF (XHI.LT.100.0) GO TO 15
      TEP(1)=TE1+DELTR*1.48
      TEP(2)=TE2+DELTR*2.16
      TEP(3)=TE3+DELTR*3.08
      TEP(4)=TE4+DELTR*3.08
      GO TO 16
   15 TEP(1)=TE1+DELTR*1.0
      IF (XHI.LE.80.0) TEP(1)=TE1+DELTR*0.5
      TEP(2)=TERO(DELTR,TE2,190.0,1.0,0.0,1.8,0.0)
      TEP(3)=TERO(DELTR,TE3,300.0,2.0,0.0,2.54,0.0)
      TEP(4)=TERO(DELTR,TE4,400.0,2.0,0.0,2.54,0.0)
   16 NI=6
      CALL T1400(FI,HOUR,TE6)
      IF (TE6.GE.TE4) GO TO 2
      TE5=TE4
      GO TO 11
    2 CALL TE600(FI,TD,HOUR,TE5)
      IF ((TE6-TE5).GE.400.0) GO TO 18
      IF (TE6.GE.TE5) GO TO 11
      TE5=TE6
   11 TE6=TE5+400.0
   18 IF (XHI.LT.100.0) GO TO 17
      TEP(5)=TE5+DELTR*3.08
      TEP(6)=TE6+DELTR*3.08
      GO TO 3
   17 TEP(5)=TERO(DELTR,TE5,600.0,2.5,0.0,2.8,0.0)
      TEP(6)=TE6+DELTR*6.16
      IF (XHI.LE.80.0) TEP(6)=TE6+DELTR*9.25
      IF (TEP(4).GT.TEP(5)) TEP(5)=TEP(4)
      IF (TEP(5).GT.TEP(6)) TEP(6)=TEP(5)
    3 IF (ABS(FI).GT.60.) GO TO 9
      NI=7
      VS=EXP(0.1*FI)
      VS=VS+1/VS+2
      VS=4./VS
      VS25=VS
      VSM=VS
      IF (HOUR.GT.6.5.AND.HOUR.LT.21.) CALL OPFUN(FI,HOUR,TD,VS,VS25,
     *VSM)
      CALL TE250(FI,HOUR,TE7)
      IF (XHI.LT.100.0) GO TO 19
      TEP(7)=TE7+DELTR*3.08
      GO TO 20
   19 TEP(7)=TERO(DELTR,TE7,250.0,1.0,0.0,1.8,0.0)
   20 IF (HOUR.GE.6.5.AND.HOUR.LE.21.) GO TO 6
    9 IF (TEP(1).GT.TEP(3)) TEP(1)=TEP(3)
      IF (TEP(2).GT.TEP(3)) TEP(2)=TEP(3)
      IF (ABS(FI).LE.60.) GO TO 10
      TV=TEP(2)+(TEP(4)-TEP(2))*0.5238
      IF (TEP(3).LT.TV) TEP(3)=TV
      GO TO 4
   10 IF ((TEP(7).GT.TEP(3)).OR.(TEP(7).LT.TEP(2))) TEP(7)=TEP(3)
      GO TO 4
    6 NI=9
      CALL TE350(FI,HOUR,TE8)
      CALL TEMAX(FI,HOUR,HP1(9),TE9)
      IF (XHI.LT.100.0) GO TO 21
      TEP(8)=TE8+DELTR*3.08
      TEP(9)=TE9+DELTR*2.16
      IF (HP1(9).GE.230.0) TEP(9)=TE9+DELTR*3.08
      GO TO 22
   21 TEP(8)=TERO(DELTR,TE8,350.0,2.0,0.0,2.54,0.0)
      TEP(9)=TERO(DELTR,TE9,HP1(9),1.0,0.0,1.8,0.0)
   22 IF ((HP1(9).LE.250.).AND.(TEP(2).GT.TEP(9))) TEP(2)=TEP(9)
      IF ((HP1(9).GT.250.).AND.(TEP(2).GT.TEP(7))) TEP(2)=TEP(7)
    4 CONTINUE
      CALL ORDER(HP1,TEP,HP)
      DO 1 I=2,NI
      IF (ABS(HP(I)-HP(I-1)).LE.0.5) GO TO 5
      M(I)=(TEP(I)-TEP(I-1))/(HP(I)-HP(I-1))
      GO TO 1
    5 M(I)=0.
    1 CONTINUE
      M(NI+1)=M(NI)
      NN=NI+1
      DO 7 I=2,9
    7 D(I)=20.
      IF (NI.LE.7) GO TO 8
      IF ((TEP(5).GE.TEP(3)).AND.(TEP(5).GE.TEP(4))) GO TO 13
      DO 12 I=2,7
   12 D(I)=2.
      GO TO 8
   13 CONTINUE
      DO 14 I=2,4
   14 D(I)=2.
    8 RETURN
      END
C
      FUNCTION  XINT(Y,T,N,M)
      REAL Y(N,M),DAY(13),HT(29),FI(12),FI1(12),FI2(4)
      COMMON /BLOCD/M1,IDAY
      DATA HT/0.,1.,2.,3.,4.,4.5,5.,5.5,6.,6.5,7.,7.5,8.,9.,10.,11.,12.,
     *13.,14.,15.,16.,17.,18.,19.,20.,21.,22.,23.,24./
      DATA DAY/1.,32.,60.,91.,121.,152.,182.,213.,244.,274.,305.,
     *335.,366./
      DATA FI1/-90.,-80.,-70.,-60.,-50.,-40.,40.,50.,60.,70.,80.,90./
      DATA FI2/-60.,-40.,40.,60./
C     TA - TABLE , T - EITHER TIME, OR LATITUDE
C     N - NUMBER FOR INTERPOLATION, ONE OF DIMENSIONS OF TABLE
C     N=12- INTERPOLATION ON TD AND FI1
C     N>12- INTERPOLATION ON TD AND LT
C     N= 4- INTERPOLATION ON TD AND FI2
      M2=M1+1
      ALF=(IDAY-1)/(DAY(M2)-DAY(M1))
      IF (M2.GT.12) M2=1
      IF (N-12) 1,3,8
    1 DO 2 I=1,4
    2 FI(I)=FI2(I)
      GO TO 5
    3 DO 4 I=1,12
    4 FI(I)=FI1(I)
    5 DO 6 I=2,N
      J2=I
      IF (T.LE.FI(I)) GO TO 7
    6 CONTINUE
    7 J1=J2-1
      BT=(T-FI(J1))/(FI(J2)-FI(J1))
      GO TO 11
    8 J=0
      IF (N.EQ.17) J=9
      DO 9 I=1,28
      J1=J+I
      IF(T.LE.HT(J1+1)) GO TO 10
    9 CONTINUE
   10 BT=(T-HT(J1))/(HT(J1+1)-HT(J1))
      J1=J1-J
      J2=J1+1
      IF (J2.GT.N) J2=1
   11 X1=Y(J1,M1)
      X2=Y(J2,M1)
      X3=Y(J1,M2)
      X4=Y(J2,M2)
      XINT=X1+ALF*(X3-X1)+BT*(X2-X1)+ALF*BT*(X4-X2-X3+X1)
      RETURN
      END
C
      FUNCTION TM(F,TD,A)
      DIMENSION A(3,13),FI(13),B(3),C(3)
      DATA FI/-90.,-80.,-70.,-60.,-40.,-30.,0.,30.,40.,60.,70.,80.,90./
      I=1
    2 I=I+1
      IF(F.LE.FI(I)) GO TO 1
      GO TO 2
    1 DO 3 K=1,3
      B(K)=A(K,I)
      C(K)=A(K,I-1)
    3 CONTINUE
      X1=XTD(TD,C(1),C(2),C(3))
      X2=XTD(TD,B(1),B(2),B(3))
      TM=X1+(F-FI(I-1))/(FI(I)-FI(I-1))*(X2-X1)
      RETURN
      END
C
      FUNCTION XTD(TD,A,B,C)
      DATA D/1./,E/32./,F/74./,G/105./,H/258./,S/288./,P/152./,
     *     Q/213./,R/335./
      IF(TD.GE.D.AND.TD.LE.E.OR.TD.GE.R) GO TO 1
      IF(TD.GT.E.AND.TD.LT.F) GO TO 2
      IF(TD.GE.F.AND.TD.LE.G.OR.TD.GE.H.AND.TD.LE.S) GO TO 3
      IF(TD.GT.G.AND.TD.LT.P) GO TO 4
      IF(TD.GT.Q.AND.TD.LT.H) GO TO 5
      IF(TD.GE.P.AND.TD.LE.Q) GO TO 6
      IF(TD.GT.S.AND.TD.LT.R) GO TO 7
    1 XTD=A
      GO TO 8
    2 XTD=A+(TD-E)/(F-E)*(B-A)
      GO TO 8
    3 XTD=B
      GO TO 8
    4 XTD=B+(TD-G)/(P-G)*(C-B)
      GO TO 8
    5 XTD=C+(TD-Q)/(H-Q)*(B-C)
      GO TO 8
    6 XTD=C
      GO TO 8
    7 XTD=B+(TD-S)/(R-S)*(A-B)
    8 RETURN
      END
C
      SUBROUTINE COEF3(FI,TD,C11)
      REAL AI(7),YI(8),DELI(8),FII(7),ALI(8),BETA(8),LM(8),GAM(8)
      REAL DC1(5),DFC(5)
      COMMON /KOF/A,B1,C1,D1,B2,C2,D2,B3,C3,D3
      DATA FII/-80.,-70.,-40.,0.,40.,70.,80./
      DATA ALI/0.,0.,0.5,0.75,0.5,0.75,1.,1./
      DATA BETA/0.,0.,-0.5,-0.75,0.5,0.75,-1.,-1./
      DATA YI/0.,0.,3.,1.50,3.,4.5,4.5,3./
      DATA LM/0.,0.,15.,-15.,-60.,65.,-25.,-75./
      DATA DELI/0.,0.,0.3,0.3,0.4,0.25,0.8,1./
      DATA GAM/0.,0.,62.,15.,-25.,75.,-15.,-65./
C----------------------------------------------------------------------
      SP(X)=0.5*(1+SIGN(1.,X))
      SM(X)=0.5*(1-SIGN(1.,X))
      AFI=ABS(FI)
      YD=(TD+29.5)/30.5
      C3=11.
      D3=6.
      Y=YD
      IF(Y.GT.7.) Y=14-Y
      SS2=EFUN(FI,20.,5.,2)
      SS3=EFUN(FI,30.,5.,2)
      SS7=EFUN(FI,70.,5.,2)
      SS56=EFUN(FI,56.,5.,2)
C--------- CALCULATION OF COEFFICIENT A -------------------------------
      Y0=ZFUN(4.,3.,FI/5)
      DEL=ZFUN(3.6,-1.1,(FI+90.)/5.)-ZFUN(0.3,0.3,(FI+40.)/5.)
      DEL=DEL+ZFUN(0.7,0.7,(FI-40.)/5.)+ZFUN(0.3,0.3,(FI-90.)/5.)
      AG=ZFUN(1500.,400.,(AFI-90.)/5.)+ZFUN(-250.,250.,(AFI-42.)/4.)
      AG=AG+150.*EFUN(FI,5.,17.,4)
      BG=-200.+1250.*EFUN(AFI,80.,14.,2)+350.*EFUN(AFI,30.,11.,2)
      BG=BG+250.*EFUN(FI,-5.,15.,4)
      D1=150.*EFUN(Y,8-Y0,0.6,2)*EFUN(AFI,90.,20.,4)
      D2=100.*EFUN(Y,4.,1.1,2)*EFUN(FI,-40.,5.,4)
      A=AG+BG*EFUN(Y,Y0,DEL,4)+D1+D2
C--------- CALCULATION OF COEFFICIENT B1 ------------------------------
      DEL=7.+10.*EXP(-ABS(FI-40.)/20.)
      AG=EFUN(FI,2.,25.,2)+EFUN(FI,-68.,9.2,2)
      AG=650.*(AG+EFUN(FI,68.,DEL,2))+2200.
      SLG=ZFUN(800.,500.,(AFI-80)/15)+400.*EFUN(FI,-5.,25.,4)
      AI(1)=SLG-550.*EFUN(FI,-72.,7.,2)-200.*SS7
      AI(2)=AI(1)+150*EFUN(FI,10.,15.,4)
      YI(1)=ZFUN(5.3,-0.7,(FI+48)/4.)-ZFUN(1.3,1.3,(FI-30.)/5.)+1.5*SS7
      YI(2)=ZFUN(10.,2.,(FI+24.)/15.)-1.2*EFUN(FI,33.,7.,2)-1.5*SS7
      SIG= 1.6-0.7*EFUN(FI,-60.,15.,4)
      DELI(1)=SIG
      DELI(2)=SIG+1.2*EFUN(FI,6.,16.,4)
      YP=YD
    1 DD1= -(650.*EFUN(FI,0.,20.,4)+200.*EFUN(FI,-30.,10.,4))*
     1     EFUN(YP,1.,1.,2)
      DD2= -400.*EFUN(FI,38.,10.,2)*EFUN(YP,7.,1.5,2)
      Y0=ZFUN(4.,3.,FI/10)
      DD3=-300.*EFUN(AFI,70.,5.,4)*EFUN(YP,Y0,2.5,4)
      B1=AG+DD1+DD2+DD3+300.*EFUN(YP,7.,0.6,2)*EFUN(FI,-80.,7.,2)
      SLG=AI(1)*EFUN(YP,YI(1),DELI(1),2)+AI(2)*EFUN(YP,YI(2),DELI(2),2)
      B1=B1-SLG
      IF(YP.LT.1.) GO TO 3
      IF(YP.LE.12.) GO TO 2
      B11=B1
      YP=13-YP
      GO TO 1
    3 B1=B1*(YD-12)+B11*(13-YD)
    2 CONTINUE
C------------ CALCULATION OF COEFFICIENT C1----------------------------
      AI(1)=6.5
      AI(2)=6.5+4*EFUN(Y,7.,3.,4)-1.5*EFUN(Y,5.,0.5,2)
      AI(3)= 6.5+EXP((Y-7)/2)
      AI(4)= ZFUN(5.4,0.5,(Y-1)/2)
      AI(5)= 6.7+0.8*EXP(-(Y-1)/2)
      X=Y-3.5
      AI(6)=8.5-2*X**3/(1+ABS(X)**3)
      AI(7)=6.
      I=2
    4 IF(I.EQ.7.OR.FI.LE.FII(I)) GO TO 5
      I=I+1
      GO TO 4
    5 I=I-1
      C13=AI(I)+(AI(I+1)-AI(I))/(FII(I+1)-FII(I))*(FI-FII(I))
      SLG=ZFUN(-0.55,-0.25,(YD-4.9)/0.4)+ZFUN(0.,0.3,(YD-9.)/0.4)
      DC1(1)=SLG-ZFUN(0.,0.3,(YD-12.)/0.4)+0.3*EFUN(YD,7.,0.5,2)
      SLG=ZFUN(-2.,2.,YD-3.)+ZFUN(1.,1.,(YD-7.5)/0.25)
      DC1(2)=(SLG-ZFUN(3.,3.,(YD-10.2)/0.5)-EFUN(YD,6.,0.5,2))/10.
      SLG=ZFUN(1.75,0.75,(YD-2.8)/0.4)+ZFUN(1.25,1.25,(YD-7.9)/0.3)
      DC1(3)=(SLG-ZFUN(3.,3.,(YD-9.9)/0.3))/10.
      SLG=ZFUN(0.,1.,(YD-2.)/0.4)+ZFUN(1.,1.,(YD-7.)/0.4)
      DC1(4)=(SLG-ZFUN(3.,3.,(YD-9.6)*2)-EFUN(YD,5.,0.6,2))/10.
      SLG=ZFUN(-2.,4.,(YD-3.1)*2)-ZFUN(3.5,3.5,(YD-10.4)/0.3)
      DC1(5)=(SLG-2.5*EFUN(YD,7.,1.5,4)+1.5*EFUN(YD,7.,0.7,2))/10.
      DO 227 J=1,5
      FD=-25.+10.*(J-1)
  227 DFC(J)=(ZFUN(1.,1.,FI-FD)-ZFUN(1.,1.,FI-FD-10.))/2.
      FFD=(ZFUN(1.,1.,(FI+25.)/2.)-ZFUN(1.,1.,(FI-25.)/2.))/2.
      C14=C1
      DO 228 J=1,5
  228 C14=C14+DC1(J)*DFC(J)
      C1=C14*FFD+C13*(1-FFD)
      C11=C1
C--------- CALCULATION OF COEFFICIENT D1 ------------------------------
      AN=4.E-4
      BN=ZFUN(-0.5,3.5,(Y-2.8)/0.4)*1.E-3
      CN=0.6
      AI(1)=ZFUN(1.,0.3,(Y-7)/1.5)
      AI(2)=ZFUN(0.6,-0.4,(Y-2.75)/0.35)+ZFUN(0.3,0.3,(Y-5.3)/0.45)
      FII1=ZFUN(-45.,-10.,Y-7)+ZFUN(2.5,-2.5,(Y-2.5)/0.25)
      FII2=ZFUN(37.5,-7.5,(Y-2.5)/0.25)
      DELI(1)=10.+5.*(Y-1)/6
      DELI(2)=15.
      DD1=AI(1)*EFUN(FI,FII1,DELI(1),2)
      DD2=AI(2)*EFUN(FI,FII2,DELI(2),2)+0.5*EFUN(Y,3.5,1.,4)*
     *       EFUN(FI,-67.,7.,4)
      D1=AN*FI*FI+BN*FI+CN+DD1+DD2
C--------- CALCULATION OF COEFFICIENT B2 ------------------------------
      AL=1600+(150-3.75*FI)*ZFUN(0.5,-0.5,(FI+30)/5)
      SLG=(300+1.5*FI)*ZFUN(0.5,0.5,(FI+14.)/2)-580.*SS56
      AL=AL+SLG-200.*(SS3+EFUN(FI,70.,10.,2))
      SLG=SM(FI+56)*(1375+15.625*FI)+SP(FI+56)*SM(FI-20)*(132-6.58*FI)
      SLG=SLG-225.*EFUN(FI,-40.,5.,2)+550.*EFUN(FI,28.,15.,2)
      BETA(1)=SLG+100.*EFUN(FI,80.,5.,2)
      SLG=ZFUN(2.45,-0.45,(FI-30)/20)+1.2*EFUN(FI,2.,15.,4)
      YI(1)=SLG+1.4*EFUN(FI,-63.,13.,4)+1.2*EFUN(FI,-70.,5.,2)
      DELI(1)=0.5-0.2*EFUN(FI,-72.,5.,2)-0.2*SS3
      SLG=(150.+300.*EXP(-(FI+30.)/40.))*SP(FI+30.)
      SLG=SLG+SM(FI+30)*SP(FI+56)*(450.+17.3*(FI+30.))
      SLG=SLG+50.*EFUN(FI,-80.,5.,2)+200.*SS3
      BETA(2)=SLG+350.*EFUN(FI,58.,10.,2)
      SLG=ZFUN(6.5,-1.1,(FI+80.)/20.)+1.7*EFUN(FI,-2.,13.,4)
      YI(2)=SLG-2.4*EFUN(FI,68.,20.,2)
      SLG=ZFUN(0.75,0.45,(FI+16)/3)+ZFUN(-.35,-0.35,(FI-10)/10)
      SLG=SLG+0.3*EFUN(FI,80.,5.,2)-0.25*EFUN(FI,32.,5.,2)
      DELI(2)=SLG+0.4*EFUN(FI,-40.,5.,2)
      D0=450.*EFUN(FI,2.,20.,4)*EFUN(YD,9.,1.5,4)
      DD1=-100.*EFUN(Y,2.8,0.8,2)*EFUN(FI,-56.,5.,4)
      DD2=-300.*EFUN(Y,5.2,0.8,2)*EFUN(FI,56.,6.,4)
      B2=ZFUN(AL,-BETA(1),(Y-YI(1))/DELI(1))+D0+DD1+DD2
      B2=B2+ZFUN(BETA(2),BETA(2),(Y-YI(2))/DELI(2))
C--------- CALCULATION OF COEFFICIENT C2 ------------------------------
      AL=ZFUN(15.55,-0.55,(FI+35)/2.5)+ZFUN(0.55,0.55,(FI-18)/10)
      AL=AL+0.5*EFUN(FI,-10.,5.,2)+0.95*SS56-1.1*SS2
      BETA(1)=ZFUN(-0.5,0.5,(FI+63)/3.5)+1.1*EFUN(FI,-25.,10.,4)+
     1     SS3-SS56+1.1*EFUN(FI,75.,10.,4)
      YI(1)=ZFUN(4.3,-1.8,(FI+80)/38.)+1.8*EFUN(FI,70.,12.,2)
      DELI(1)=ZFUN(1.,0.5,(FI-80.)/8.)-0.25*SS3
      D0=EFUN(FI,0.,5.,4)*(EFUN(YD,3.,1.5,4)+0.5*EFUN(YD,8.,1.5,4))
      DD1=EFUN(AFI,30.,5.,4)*EFUN(Y,7.,1.7,4)*ZFUN(-2.,-1.,FI/10)
      DD2=1.75*EFUN(FI,-56.,5.,4)*EFUN(Y,7.,0.6,2)
      C2=ZFUN(AL,BETA(1),(Y-YI(1))/DELI(1))+D0+DD1+DD2
C---------- CALCULATION OF COEFFICIENT D2 -----------------------------
      D2=ZFUN(4.,1.,(AFI-80)/5.)+ZFUN(0.5,-0.5,(AFI-15.)/2.5)
      D2=D2+0.5*EFUN(FI,-56.,5.,2)+2*SS2
      D2=D2-1.2*EFUN(YD,10.,1.5,2)*EFUN(FI,-20.,5.,2)
      YI(3)=ZFUN(3.75,-1.25,(FI-35)/2.5)
      YI(5)=3-0.25*(FI+30)
      DELI(3)=0.1*YI(3)
      DELI(5)=ZFUN(0.375,0.125,(FI+35)/2.5)
      DO 6 I=3,8
      D2=D2+ZFUN(ALI(I),BETA(I),(Y-YI(I))/DELI(I))*
     1   ZFUN(.5,.5,(FI-LM(I))/2.5)*ZFUN(.5,-.5,(FI-GAM(I))/2.5)
    6 CONTINUE
C------------ CALCULATION OF COEFFICIENT B3 ---------------------------
      AL=ZFUN(2090.,-190.,(FI+63)/4)+250.*ZFUN(1.,1.,(FI-24.)/2.5)
      AL=AL-250.*ZFUN(1.,1.,(FI+32.)/5.)+ZFUN(190.,190.,(FI-68.)/2.5)
      AL=AL-350.*EFUN(FI,56.,10.,2)
      SLG=ZFUN(175.,-675.,(FI+80)/10.3)+ZFUN(162.,162.,(FI+36)/10)
      BETA(1)=SLG-225.*(SS3-EFUN(FI,64.,13.,2))
      SLG=ZFUN(4.1,-1.1,(FI+54)/6)+ZFUN(.25,.25,(FI+15)/2.5)
      YI(1)=SLG-1.2*SS2-3*EFUN(FI,50.,19.,2)
      DELI(1)=0.5-0.2*EFUN(AFI,70.,5.,2)+0.2*EFUN(FI,40.,5.,2)
      SLG=200.*(ZFUN(1.,1.,(FI+40)/6)-ZFUN(1.,1.,(FI-30.)/10.))
      BETA(2)=SLG+130.*EFUN(FI,-27.,7.,2)+450.*EFUN(FI,52.,10.,2)
      DELI(2)=0.4+0.45*EFUN(FI,0.,20.,4)+0.9*SS2
      SLG=ZFUN(6.3,0.7,(FI+17)/3)+ZFUN(-1.25,-1.25,(FI-25)/2.5)
      YI(2)=SLG-0.6*SS56
      DD1=-150.*EFUN(Y,1.,1.4,4)*EFUN(FI,-70.,5.,4)
      Y0=ZFUN(11.,-1.5,(FI+15)/2.5)
      DD2=200.*EFUN(FI,0.,18.,4)*(ZFUN(1.,1.,(YD-7.5)/.25)-
     1       ZFUN(1.,1.,(YD-Y0)/.25))
      DD3=250.*EFUN(YD,11.5,1.,4)*EFUN(FI,5.,7.,4)
      B3=ZFUN(AL,BETA(1),(Y-YI(1))/DELI(1))+DD1+DD2+DD3
      B3=B3+ZFUN(BETA(2),BETA(2),(Y-YI(2))/DELI(2))-A
      B1=B1-B3*EFUN(C1,C3,D3,2)-A
      B2=B2-B3*EFUN(C2,C3,D3,2)-A
      RETURN
      END
C
      SUBROUTINE COEF4(FI,TD,C11)
      REAL AI(9),FII(9),DELI(9),AL(6),BETA(6)
      COMMON /KOF/A,B1,C1,D1,B2,C2,D2,B3,C3,D3
      DATA PI/3.14159/,
     ,AL/1.5,0.8,1.6,1.,7.,1./,BETA/2.3,5.,7.3,1.5,1.5,1.5/,
     ,AI(7),AI(8),AI(9)/1.,1.5,1./,FII(7),FII(8),FII(9)/0.,32.,40./,
     ,DELI(7),DELI(8),DELI(9)/7.,9.0,13./
      SP(X)=0.5*(1+SIGN(1.,X))
      SM(X)=0.5*(1-SIGN(1.,X))
      AFI=ABS(FI)
      YD=(TD+29.5)/30.5
      Y=YD
      IF(Y.GT.7.) Y=14-Y
C _______ CALCULATION OF COEFFICIENT A ________
      Z2=EFUN(FI,90.,7.,4)
      Z3=EFUN(FI,-90.,7.,4)
      C=250*(EFUN(Y,1.,1.5,2)*Z2+EFUN(Y,7.,1.5,2)*Z3)
      DEL1=2+0.3*AFI/80.
      DEL2=0.3+1.4*EFUN(FI,-60.,15.,4)
      D=500.*EFUN(Y,7.,DEL2,2)*EFUN(FI,-60.,10.,4)
      AG=1000-600*COS(PI*FI/100)+500*EFUN(FI,0.,18.,4)
      IF (FI.GT.60..AND.FI.LE.80.) B=-5130+88*FI
      IF (FI.GE.-80..AND.FI.LT.-60.) B=-4850-85*FI
      IF (FI.GT.80.) B=5100-40*FI
      IF (FI.LT.-80.) B=5550+45*FI
      IF (AFI.LE.60.) B=0.056*(FI*FI-15*FI-150*(18-FI*FI/200)*
     *COS(PI*FI/24))
      Z1=ZFUN(0.5,0.5,(FI+10)/5)
      A=400*EXP(-(Y-1)/1.5)*EFUN(FI,57.,10.,4)+C+AG
      A=A+B*(EFUN(Y,7.,DEL1,4)*Z1+EFUN(Y,1.,DEL1,4)*(1-Z1))+D
C____________CALCULATION OF COEFFICIENT B1______________________________
      AG=ZFUN(200.,200.,(AFI-40.)/5.)-31.67*AFI+200*EFUN(AFI,70.,5.,2)
      AG=1800.+AG+250.*EFUN(FI,60.,7.,2)*EFUN(Y,7.,0.8,2)
      Y1=SM(FI-10)*3.+SP(FI-10)*(3+1.2*(1-EXP(-(FI-10)/5)))
      Y2=SM(FI-10)*(11.5-0.00097*(FI+50)*(FI+50))
      Y2=Y2+SP(FI-10)*(8+0.00375*(FI-10)+1.5*(1-EXP(-(FI-10)/5)))
      Y2=Y2-EFUN(FI,-10.,5.,2)
      DEL1=1.75-1.00*(EFUN(FI,-10.,5.,2)+EFUN(FI,10.,5.,2))
      DEL2=1.75
      B0=-SM(FI+40.)*15.*(FI+40.)
      B0=B0+SP(FI+40.)*400.*(1-EXP(-(FI+40.)/10.)+EXP((FI-80.)/30.))
      B0=B0-200.*EFUN(AFI,20.,5.,2)-100.*EFUN(FI,45.,10.,4)
      D2=400.*EFUN(FI,0.,10.,4)
      D1=0.5*D2
      BG1=B0+D1
      BG2=B0+D2
      YP=YD
    1 B1=AG+BG1*EFUN(YP,Y1,DEL1,2)+BG2*EFUN(YP,Y2,DEL2,2)
      IF(YP.LT.1.) GO TO 3
      IF(YP.LE.12.) GO TO 2
      B11=B1
      YP=13-YP
      GO TO 1
    3 B1=B1*(YD-12)+B11*(13-YD)
    2 CONTINUE
C __________CALCULATION OF COEFFICIENT C1_______________________________
      FIC=FI
      YC=Y
      IF(YC.LE.4.) GO TO 111
      YC=8.-YC
      FIC=-FIC
  111 F1=ZFUN(1.,-1.,(YC-1.5)/0.2)/2.
      F2=ZFUN(1.,1.,(YC-1.5)/0.2)*ZFUN(1.,-1.,(YC-2.5)/0.2)/4.
      F3=ZFUN(1.,1.,(YC-2.5)/0.2)*ZFUN(1.,-1.,(YC-3.5)/0.2)/4.
      F4=ZFUN(1.,1.,(YC-3.5)/0.2)/2.
      R1=ZFUN(5.5,0.5,(FIC+65.)/3.5)+EFUN(FIC,-30.,12.,4)
      R1=R1+ZFUN(1.25,1.25,(FIC-22.)/4.)
      R2=ZFUN(5.75,0.75,(FIC+65.)/3.5)+0.5*EFUN(FIC,-30.,5.,2)
      R2=R2-0.85*EFUN(FIC,-2.,13.,4)+ZFUN(0.9,0.9,(FIC-22.)/4.)
      R3=ZFUN(5.85,0.85,(FIC+69.)/3.)+0.6*EFUN(FIC,-30.,5.,2)
      R3=R3-EFUN(FIC,0.,15.,4)+ZFUN(0.25,0.25,(FIC-20.)/2.5)
      R3=R3+SP(Y-4.)*1.3*EFUN(FIC,70.,12.,4)
      R3=R3-0.7*SM(Y-4.)*EFUN(FIC,70.,5.,2)
      R4=ZFUN(7.,-1.3,(FIC+25.)/7.5)+ZFUN(0.65,0.65,(FIC-19.)/4.5)
      R4=R4-ZFUN(1.,1.,(FIC-65.)/2.5)/2.
      R4=R4-0.375*ZFUN(1.,1.,(FIC+76.)/2.5)*ZFUN(1.,-1.,(FIC+45.)/2.)
      G1=(2.1*EXP(-ABS((FIC-70.)/7.))-EXP(-ABS((FIC-80.)/5.)))*
     *   ZFUN(1.,-1.,(YC-2.5)/0.2)/2.
      G2=-0.5*EFUN(FIC,5.,10.,4)*ZFUN(1.,-1.,(Y-2.5)/0.2)/2.
      C1=F1*R1+F2*R2+F3*R3+F4*R4+G1+G2
      C11=C1
C____________CALCULATION OF COEFFICIENT D1______________________________
      D1=(4.-3.2*EFUN(FI,0.,40.,2))*SP(FI+40.)*SM(FI-30.)
      D1=D1+2.177*SP(FI-30)+1.8*EXP(-ABS((FI-80)/3))
      D1=D1+2.82*SM(FI+40.)+0.2*EFUN(FI,50.,5.,2)
      AI(1)=EFUN(Y,7.,1.,2)
      AI(2)=-EFUN(Y,7.,1.5,2)+0.7*EFUN(Y,5.,0.5,2)-0.8*EFUN(Y,1.,1.,2)
      AI(3)=-0.2*EFUN(Y,7.,1.5,2)
      AI(4)=-0.3*EFUN(Y,7.,2.5,2)
      AI(5)=EFUN(Y,1.,1.5,2)
      AI(6)=0.8*EFUN(Y,5.,1.,2)
      FII(1)=-80.
      FII(2)=-70.
      FII(3)=-10.
      FII(4)=10.
      FII(5)=40.
      FII(6)=70.
      DO 6 I=1,6
    6 D1=D1+AI(I)*EFUN(FI,FII(I),5.,2)
C______________CALCULATION OF COEFFICIENT B2____________________________
      FII(1)=ZFUN(-70.,10.,(Y-5.5)/0.25)
      AI(1)=SM(Y-4)*ZFUN(250.,+750.,(Y-4)/0.5)+
     1      SP(Y-4)*ZFUN(250.,-250.,(Y-4)/0.5)
      FII(2)=ZFUN(-45.,5.,(Y-3.5)/0.25)
      AI(2)=ZFUN(950.,50.,(Y-3.5)/0.25)+ZFUN(50.,50.,(Y-5.5)/0.25)
      FII(3)=0.
      AI(3)=ZFUN(265.,65.,(YD-7)/1.3)+ZFUN(65.,65.,-(YD-3.3)/0.3)
      FII(4)=ZFUN(50.,10.,(Y-3.7)/0.4)-10*EFUN(Y,7.,1.2,2)
      AI(4)=1100-SP(Y-2)*350*(1-EXP(-(Y-2)/0.8))+150*EXP((Y-7)*2)
      FII(5)=ZFUN(70.,10.,(Y-3.5)/0.25)
      AI(5)=SP(Y-4)*ZFUN(0.,-500.,(Y-4)/0.8)
      IF (FI.LE.FII(1)) B2=AI(1)
      IF (FI.GT.FII(1).AND.FI.LE.FII(2))
     1    B2=AI(1)+(AI(2)-AI(1))/(FII(2)-FII(1))*(FI-FII(1))
      IF (FI.GT.FII(2).AND.FI.LE.FII(3))
     1    B2=AI(2)+(AI(3)-AI(2))*(FI-FII(2))/(FII(3)-FII(2))**3*
     2   (FII(2)*FII(2)+FI*FII(2)+3*FI*FII(3)-3*FII(2)*FII(3)-2*FI*FI)
      IF (FI.GT.FII(3).AND.FI.LE.FII(4))
     1    B2=AI(3)+(AI(4)-AI(3))*(FI-FII(3))/(FII(4)-FII(3))**3*
     2   (FII(3)*FII(3)+FI*FII(3)+3*FI*FII(4)-3*FII(3)*FII(4)-2*FI*FI)
      IF (FI.GT.FII(4).AND.FI.LE.FII(5))
     1    B2=AI(4)+(AI(5)-AI(4))*(FI-FII(4))/(FII(5)-FII(4))
      IF (FI.GT.FII(5)) B2=AI(5)
C_____________CALCULATION OF COEFFICIENT C2_____________________________
      C2=-0.6*EFUN(Y,3.5,0.8,4)*EFUN(FI,80.,20.,2)+16.
      C2=C2+EFUN(YD,4.5,1.,4)*EFUN(FI,0.,7.,2)
      AI(1)=1.5+0.125*(Y-2)
      FII(1)=-70.+6*EFUN(Y,4.,1.5,2)
      DELI(1)=15.+6*EFUN(Y,4.5,1.,2)
      AI(2)=ZFUN(0.75,-0.75,(Y-5.3)/0.8)
      FII(2)=ZFUN(0.,28.,(Y-7)/1.4)
      DELI(2)=ZFUN(20.,10.,Y-7)
      AI(3)=ZFUN(0.,1.6,(Y-1)/2.4)
      FII(3)=ZFUN(10.,20.,(Y-1.4)/1.3)
      DELI(3)=10+1.67*(Y-3)
      DO 4 I=1,3
    4 C2=C2+AI(I)*EFUN(FI,FII(I),DELI(I),2)
      C2=C2+EXP(-ABS(FI-80.)/5.)-EFUN(FI,70.,5.,2)*EFUN(Y,5.,0.5,2)
C_________________CALCULATION OF COEFFICIENT D2_________________________
      D2=ZFUN(4.,-0.5,(FI+75.)/2.5)+ZFUN(-0.5,-0.5,(FI+5)/2.5)
      D2=D2+ZFUN(0.5,0.5,(FI-45.)/2.5)+ZFUN(0.5,0.5,(FI-75)/2.5)
      D2=D2-0.5*EFUN(FI,-20.,5.,2)-.5*EFUN(FI,30.,5.,2)
      D2=D2-ZFUN(1.,1.,(Y-4.)*2.)*EFUN(FI,-28.,9.,4)/2.
      DO 7 I=7,9
    7 D2=D2+AI(I)*EFUN(FI,FII(I),DELI(I),4)*EFUN(Y,AL(I-3),BETA(I-3),2)
C__________________CALCULATION OF COEFFICIENTS B3,C3,D3__________________
      C3=11.
      D3=6.
      AG=1200.-900.*EFUN(FI,0.,20.,2)+200.*EFUN(FI,-60.,15.,2)
      AG=AG+300.*EFUN(FI,60.,10.,2)
      AN=-1100.*SP(AFI-80.003)+SM(AFI-80.003)*
     1    (ZFUN(-1100.,1000.,(FI+80.003)/12.)-ZFUN(1000.,1000.,
     2    (FI-80.003)/12.))+110.*EFUN(FI,0.,15.,4)
      BL=ZFUN(360.,700.,(AFI-68)/3.)
      BL=BL+ZFUN(225.,-225.,(AFI-(40.-4*SP(FI)))/5)
      BL=-SIGN(1.,FI)*(BL-110*EFUN(FI,0.,15.,4))
      Y0=2.2+0.013*FI+0.022*AFI+2*EFUN(FI,-47.,20.,4)
      Y0=Y0+1.3*EFUN(FI,57.,8.,4)
      Y0=Y0-EFUN(FI,-40.,5.,2)
      D0=ZFUN(1.2,-0.7,(FI+80)/5)+ZFUN(0.7,0.7,(FI-80)/8)
      D0=D0+0.5*EFUN(FI,-52.,7.,2)
      DD1=EFUN(FI,65.,14.,4)*350.*EFUN(Y,1.,1.5,2)
      DD1=DD1+300.*EFUN(Y,7.,0.5,2)*EFUN(FI,32.,7.,2)
      DD2=-EFUN(FI,-62.,15.,4)*400*EFUN(Y,7.,1.8,2)
      B3=AG+ZFUN(AN,BL,(Y-Y0)/D0)-DD1+DD2
      B3=B3-120.*ZFUN(1.,-1.,(FI+75.)*4.)*EFUN(Y,5.5,1.5,4)
      RETURN
      END
c
      REAL FUNCTION ZFUN(A,B,C)
      CC=C*C
      C4=CC*CC
      CC=C4*C4
      CC=(CC+256.)**0.125
      ZFUN=A+B*C/CC
      RETURN
      END
c
      REAL FUNCTION EFUN(A,B,C,N)
      D=(A-B)/C
      D2=D*D
      IF (N.GT.2) D2=D2*D2
      EFUN=EXP(-(80.*D2)/(80.+D2))
      RETURN
      END
C *********************************************************************
